/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2024
 * si5351_b
 * Arduino 1.8.19
 * Basada en: 10kHz to 120MHz VFO by CesarSound - ver 1.0 - Dec/2020.
*/

char TITULO[] = "   --  SI5351  --";

#include <SPI.h>

//___________OLED_________
#include "olex.h"
#include <Wire.h>

#include <si5351.h>  //Etherkit  https://github.com/etherkit/Si5351Arduino

// User  preferences
//------------------------------------------------------------------------------------------------------------
#define FREQ_INIT \
  1000000  // Enter your initial frequency at startup,  ex: 7000000 = 7MHz,
           // 10000000 = 10MHz, 840000 = 840kHz.
//------------------------------------------------------------------------------------------------------------

//__________ENCODER_______
#include <RotaryEncoder.h>
#define PIN_IN1 2
#define PIN_IN2 3
#define EBOTON 4
RotaryEncoder encoder(PIN_IN1, PIN_IN2, RotaryEncoder::LatchMode::TWO03);

//_______________________________________
// unsigned long freq = FREQ_INIT;
unsigned long fstep;
unsigned long long pll_freq = 90000000000ULL;
char stp_S[10];
#define FRE_MIN 10000
#define FRE_MAX 120000000

Si5351 si5351;

long posicion;
long newPos;
long frecuencia;
char nc = 2;
int tiempo;
bool estado;
char digitos[12] = {0, 0, 1, 0, 0, 0, 0, 0, 0};
long tmp;

void printLinea(void) {
  int z;
  ModeFont = 2;
  for (z = 0; z < 3; z++) {
    xCaracterAT(z * 2, 2, 48 + digitos[z]);
  }
  for (z = 3; z < 9; z++) {
    xCaracterAT((z + 1) * 2, 2, 48 + digitos[z]);
  }
  xCaracterAT(6, 2, 46);  //.

  unsigned int m = frecuencia / 1000000;
  unsigned int k = (frecuencia % 1000000) / 1000;
  unsigned int h = (frecuencia % 1000) / 1;
  char buffer[20] = "";
  sprintf(buffer, "%03u.%03u.%03u", m, k, h);
  // ModeFont=0; xStringAT(0,4,buffer);
  ModeFont = 2;
  xStringAT(14, 4, "MHz");
  Serial.print("    Display FRECU=");
  Serial.println(buffer);

  tunegen();
}

void setup() {
  Serial.begin(9600);
  Serial.println(TITULO);

  pinMode(EBOTON, INPUT_PULLUP);
  pinMode(PIN_IN1, INPUT_PULLUP);
  pinMode(PIN_IN2, INPUT_PULLUP);

  OleInit();
  xclearDisplay();
  ModeFont = 0;
  xStringAT(0, 0, TITULO);

  bool i2c_found = si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0);
  if (!i2c_found) {
    Serial.println("Device not found on I2C bus!");
  }

  si5351.output_enable(SI5351_CLK0, 1);  // 1 - Enable  / 0 - Disable CLK
  si5351.output_enable(SI5351_CLK1, 0);
  si5351.output_enable(SI5351_CLK2, 0);
  si5351.drive_strength(
      SI5351_CLK0, SI5351_DRIVE_2MA);  // Output current  2MA, 4MA, 6MA or 8MA

  frecuencia = FREQ_INIT;
  printLinea();
}

void loop() {
  char ncx;
  delay(10);
  tiempo++;
  if (tiempo > 40) {
    if (nc < 3)
      ncx = nc;
    else
      ncx = nc + 1;

    ModeFont = 2;
    if (estado == 1) {
      estado = 0;
      xCaracterAT(ncx * 2, 2, 48 + digitos[nc]);
    } else {
      estado = 1;
      ModeFont = 2;
      xStringAT(ncx * 2, 2, " ");
    }
    tiempo = 0;
  }

  encoder.tick();
  newPos = encoder.getPosition();

  if (posicion != newPos) {
    posicion = newPos;
    digitos[nc] = newPos;

    if (digitos[nc] < 0) {
      encoder.setPosition(9);
      digitos[nc] = 9;
    }
    if (digitos[nc] > 9) {
      encoder.setPosition(0);
      digitos[nc] = 0;
    }

    frecuencia = 0;
    long multi = 1;
    for (int z = 8; z >= 0; z--) {
      tmp = digitos[z];
      tmp *= multi;
      frecuencia += tmp;
      multi *= 10;
    }
    printLinea();
  }

  if (LOW == digitalRead(EBOTON)) {
    while (LOW == digitalRead(EBOTON))
      delay(2);
    nc--;
    if (nc < 0)
      nc = 8;
    encoder.setPosition(digitos[nc]);
    printLinea();
    Serial.println("botonE");
  }
}

void tunegen() {
  si5351.set_freq_manual(frecuencia * 100ULL, pll_freq, SI5351_CLK0);
}
